{$g+}
{
 A simple implementation of classic video game "PONG"

 Author:  Jozsef Laszlo
 Status:  Done, tested with DOS,Windows XP,DOSBOX
}
program TVTenis;

uses dos,crt;

type
   player = record
    x,y : integer;
     x2 : integer;
     dy : integer;
     oy : integer;
    ctr : integer;
     sc : byte;
   end;

const
   { VGA bitplanes for the different types }
   cl_ball = 1; { ball }
   cl_pl0  = 2; { player 1 }
   cl_pl1  = 4; { player 2 }
   cl_fld  = 8; { playfield }

   { "Els" bjtmaszkok a vzszintes vonalhzshoz }
   { byte masks for the horizontal lines - fitst bytes }
   fMsk  : Array[0..7]  of byte=($ff,$7f,$3f,$1f,$0f,$07,$03,$01);
   { "Utols" bjtmaszkok a vzszintes vonalhzshoz }
   { byte masks for the horizontal lines - last bytes }
   lMsk  : Array[0..7]  of byte=($80,$c0,$e0,$f0,$f8,$fc,$fe,$ff);

   vxt : array[0..1] of integer=(4,7);
   vyt : array[0..1,0..1] of integer=((1,2),(2,4));

    rx : array[0..1] of integer=(3,6);
var
   { original keyboard IRQ address }
   OldKeyIRQ   : procedure;
   { keyboard table for the new keyboard IRQ routine }
   KTB         : array[0..127] of boolean;
   r0,r1,r2,r3 : word;

   i,j,k,l : integer;

      pl : array[0..1] of player;

     bla : word;

  gameover : boolean;

   {hang - sound on/off}
     snd : boolean;

   {utomeret - size }
     len : integer;
   {sebesseg - speed }
     spd : byte;
   {fok - angle }
     ang : byte;

   {auto - auto/manual }
    auto : boolean;

handicap : boolean;

    miny,
    maxy : integer;

   bx,by : integer;
   vx,vy : integer;

   gtype : byte;

{
  Here comes some binary data included into the code segment ...
  I love this trick
}

{ ikon means icon ...}
procedure ikon0;                                                assembler;
asm
   db 2 {Width}
   db 5 {Height}
   db 10010101b,10011100b { bitmap }
   db 10010101b,01010000b
   db 10010101b,01011100b
   db 11110101b,01010000b
   db 10010101b,10011100b
end;

procedure ikon1;                                                assembler;
asm
   db 2 {W}
   db 5 {H}
   db 10101110b,10001110b
   db 10101010b,10001000b
   db 11101110b,10001110b
   db 10101010b,10001000b
   db 10101010b,11101000b
end;

procedure ikon2;                                                assembler;
asm
   db 2 {W}
   db 5 {H}
   db 11101000b,11101001b
   db 10001000b,10101001b
   db 11101000b,10101001b
   db 00101000b,10101111b
   db 11101110b,11101001b
end;

procedure ikon3;                                                assembler;
asm
   db 2 {W}
   db 5 {H}
   db 11101110b,11101110b
   db 10001010b,10000100b
   db 11101110b,11100100b
   db 10001010b,00100100b
   db 10001010b,11100100b
end;

procedure ikon4;                                                assembler;
asm
   db 3 {W}
   db 5 {H}
   db 11101110b,10000000b,00000000b
   db 00101010b,00000000b,00000000b
   db 11101010b,00000000b,00000000b
   db 10001010b,00000000b,00000000b
   db 11101110b,00000000b,00000000b
end;

procedure ikon5;                                                assembler;
asm
   db 3 {W}
   db 5 {H}
   db 11101110b,00101010b,11101000b
   db 00101010b,00101010b,10100000b
   db 11101010b,01001110b,10100000b
   db 10001010b,10000010b,10100000b
   db 11101110b,10000010b,11100000b
end;

procedure ikon6;                                                assembler;
asm
   db 1 {W}
   db 5 {H}
   db 00000000b
   db 00000000b
   db 00000000b
   db 00000000b
   db 00000000b
end;

procedure ikon7;                                                assembler;
asm
   db 1 {W}
   db 5 {H}
   db 00001000b
   db 00001100b
   db 00001000b
   db 00111000b
   db 01110000b
end;

{ sign function for integers }
function sgn(x:integer):integer;                                assembler;
asm
   xor     ax,ax
   test    x,$ffff
   jz      @q
   mov     ax,-1
   js      @q
   mov     ax,1
@q:
end;

{ keyboard interrupt handler
  this function basicly sets/resets the values in the array Ktb
  each element in the array represent a key (pressed/released)
}
procedure KeyIRQ;                                               assembler;
asm
   push    ds               { A hasznlt regiszterek elmentse }
   push    ax
   push    bx
   push    cx
   mov     ax,SEG Ktb       { Inicializlsok }
   mov     ds,ax
   xor     bh,bh
   mov     cl,bh
   in      al,60H           { A billenty SCAN kd beolvassa }
   mov     bl,al
   and     bl,7fH
   shl     al,1
   cmc
   adc     cl,00            { Trols a tblzatban }
   mov     [bx+OFFSET Ktb],cl
   in      al,61H           { A megszakts csatorna visszalltsa }
   mov     ah,al
   or      al,80H
   out     61H,al
   mov     al,ah
   nop
   nop
   nop
   out     61H,al
   cli
   mov     al,20H
   out     20H,al
   sti
   pop     cx               { Regiszterek vissza a verembl }
   pop     bx
   pop     ax
   pop     ds
   iret                     { Megszakts vge }
end;

{ install the new keyboard interrupt handler }
procedure InstallKEYirq;
begin
  GetintVec($09,@OldKeyIRQ);
  SetintVec($09,@KeyIRQ);
  fillchar(ktb,128,0);
end;

{ restore the original keyboard interrupt handler }
procedure UninstallKeyirq;
begin
  SetintVec($09,@OldKeyIRQ);
end;

{ change the write mode of the VGA }
procedure WriteMode(Mode:word);                                 assembler;
asm
   mov   dx,$3c4        { Plane rsmaszk regiszter }
   mov   ax,$0f02
   out   dx,ax          { Plane mask }
   mov   al,5           { Read/Write mode regiszter }
   mov   ah,byte [Mode] { a Mode csak 0,1,2,3 lehet !! }
   mov   dx,$3ce
   out   dx,ax          { Write Mode }
   mov   ax,$ff08
   out   dx,ax          { Bitmask    }
end;

{ wait for the vertical retrace }
procedure waitrtc;                                              assembler;
asm
   mov   dx,03dah
@wait:                  { Vrakozs a vertiklis visszafutsra }
   in    al,dx
   and   al,8
   jz    @wait
@_wait:
   in    al,dx
   and   al,8
   jnz   @_wait
end;

{ standard 640x480/16 graph mode }
procedure graphon;                                              assembler;
asm
   mov   ax,0012h
   int   10h
end;

{ standard 80x25 textmode }
procedure graphoff;                                             assembler;
asm
   mov   ax,0003h
   int   10h
end;

{ set the legacy EGA palette registers - needed in 16 colors modes }
procedure SetEGA(Regnum,Vaule:byte);                            assembler;
asm
   mov  dx,$3da
   in   al,dx
   mov  dx,$3c0
   mov  al,regnum
   out  dx,al
   mov  al,vaule
   out  dx,al
   mov  al,$20
   out  dx,al
end;

{ set a VGA palette R-G-B register }
procedure SetRGB(Palnum,R,G,B:byte);                            assembler;
asm
   mov  dx,$3c8
   mov  al,Palnum
   out  dx,al
   inc  dx
   mov  al,R
   out  dx,al
   mov  al,G
   out  dx,al
   mov  al,B
   out  dx,al
end;

{ show a simple bitmap on the screen. x is a byte coordinate! }
procedure ShBmp(x,y,color:integer; src:pointer);                assembler;
asm
   {set color}
   mov   dx,03c4h
   mov   ah,color.byte
   mov   al,02
   out   dx,ax

   push  DS
   mov   ES,SegA000

   mov   ax,80
   mul   y
   add   ax,x
   mov   di,ax

   cld
   lds   si,src
   lodsw
   mov   cx,ax


@c0:
   mov   dl,cl
   mov   bx,di
@c1:
   lodsb
   not   al
   stosb
   dec   dl
   jnz   @c1
   mov   di,bx
   add   di,80
   dec   ch
   jnz   @c0

   pop  DS
end;

{ draw a filled rectangle on the screen }
procedure Bar(X1,Y1,X2,Y2,Color:word);                          assembler;
asm
   push  2
   call  Writemode              { kettes rs md }
   mov   ES,SegA000
   cld

   mov   ax,80
   mul   Y1
   mov   di,X1
   mov   dx,di
   shr   di,3
   add   di,ax                  { Kpkezdcm }

   mov   cx,X2
   lea   bx,lMsk                { Az utols maszk meghatrozsa }
   mov   al,cl
   and   al,7
   xlat
   mov   si,ax                  { lo(SI) = last mask }
   lea   bx,fMsk                { Az els maszk meghatrozsa }
   mov   al,dl
   and   al,7
   xlat                         { al = first mask  }
   shr   cx,3
   shr   dx,3
   sub   cx,dx
   mov   dx,$3ce
   jz    @one_byte              { Ugrs, ha 1 bjtban elfr vzszintesen }

   mov   bx,Y2
   sub   bx,Y1
   inc   bx                     { BX a fggleges mretet adja  }

   dec   cx                     { CX a kzbens 255 bjtokat }
   mov   ah,al
   mov   al,8
   out   dx,ax                  { Els bjt maszk }

   mov   r0,bx
   mov   r1,di
   mov   al,Color.byte
@ficikl:                        { A tglalap bal szls bjtjai }
   mov   ah,es:[di]
   mov   es:[di],al
   add   di,80
   dec   bx
   jnz   @ficikl

   mov   di,r1
   inc   di

   jcxz  @nx                    { Ugrs, ha nincsenek kzbens bjtok }

   mov   ax,$ff08               { A kzbens bjtok 255 rtkek }
   out   dx,ax
   mov   al,Color.byte

   mov   bx,r0
   mov   r1,di
   mov   r2,cx
   mov   r3,di                  { Trolja ksbbi hasznlatra az rtkeket }

   push  si
   mov   si,cx
   mov   dx,di
@mdcikl:
   mov   cx,si
   mov   di,dx
   rep stosb                    { Egy vzszintes sor }
   add   dx,80
   dec   bx
   jnz   @mdcikl                { BX darab fggleges sor kell }

   mov   dx,$3ce
   pop   si

   mov   di,r1
   add   di,r2
                                { A jobb szls bjtok kvetkeznek }
@nx:
   mov   ax,si
   mov   ah,al
   mov   al,8
   out   dx,ax

   mov   bx,r0
   mov   al,Color.byte
@lacikl:                        { A bal szl kirajzolsa }
   mov   ah,es:[di]
   mov   es:[di],al
   add   di,80
   dec   bx
   jnz   @lacikl

   jmp   @exit

   { Rajzols, ha vzszintesen 1 bjt a szlessg }

@one_byte:
   mov   bx,si
   and   al,bl
   mov   ah,al
   mov   al,8
   out   dx,ax
   mov   cx,Y2
   sub   cx,Y1
   inc   cx
   mov   al,Color.byte
@oncikl:                        { A tglalap kirajzolsa }
   mov   ah,es:[di]
   mov   es:[di],al
   add   di,80
   loop  @oncikl
@exit:
   push  0
   call  Writemode
end;

{ show a racquet }
procedure Rcq(x,y,size,color:integer);                          assembler;
asm
   {set color}
   mov   dx,03c4h
   mov   ah,color.byte
   mov   al,02
   out   dx,ax

   {calc screen address}
   mov   ES,SegA000
   mov   ax,80
   imul  y

   sub   x,3

   mov   di,x
   mov   dx,di
   shr   di,3
   add   di,ax
   and   dl,7
   mov   cl,8
   sub   cl,dl
   mov   ax,1111110000000000b
   rol   ax,cl

   {show on screen}
   mov   cx,size
   mov   dx,y
@c0:
   cmp   dx,0
   jl    @nx
   cmp   dx,479
   jg    @nx
   mov   ES:[di],ax
@nx:
   inc   dx
   add   di,80
   loop  @c0
end;

{ hide a racquet }
procedure HideRcq(x,y,size,color:integer);                       assembler;
asm
   {set color}
   mov   dx,03c4h
   mov   ah,color.byte
   mov   al,02
   out   dx,ax

   {calc screen address}
   mov   ES,SegA000
   mov   ax,80
   imul  y

   sub   x,3

   mov   di,x
   shr   di,3
   add   di,ax
   xor   ax,ax

   {show on screen}
   mov   cx,size
   mov   dx,y
@c0:
   cmp   dx,0
   jl    @nx
   cmp   dx,479
   jg    @nx
   mov   ES:[di],ax
@nx:
   inc   dx
   add   di,80
   loop  @c0
end;

{ show the ball on the screen }
procedure Ball(x,y,color:integer);                             assembler;
asm
   {set color}
   mov   dx,03c4h
   mov   ah,color.byte
   mov   al,02
   out   dx,ax
   {calc screen address}
   mov   ES,SegA000
   mov   ax,80
   mul   y
   mov   di,x
   mov   bx,di
   shr   di,3
   add   di,ax
   mov   bla,di
   and   bl,7
   mov   cl,8
   sub   cl,bl
   mov   ax,1111110000000000b
   rol   ax,cl
   mov   cx,6
@c0:
   mov   ES:[di],ax
   add   di,80
   loop  @c0
end;

{ hide the previously showed ball }
procedure HideBall;                                             assembler;
asm
   mov   dx,03c4h
   mov   al,02
   mov   ah,cl_ball
   out   dx,ax
   mov   ES,SegA000
   xor   ax,ax
   mov   cx,6
   mov   di,bla
@c0:
   mov   ES:[di],ax
   add   di,80
   loop  @c0
end;

{ simple sound producing }
procedure beep(hz:word);
begin
 if snd then sound(hz);
 delay(10);
 nosound;
end;

{ sound if ther is a goal }
procedure goalsnd;
var i:integer;
begin
 for i:=9 downto 5 do beep(i*100);
 nosound;
end;

{ show a digital number on the screen }
procedure shdig(x,y,col,n:integer);
const
 { matrix:
     ...    for example 0:   xxx
     ...                     x x
     ...                     x x
     ...                     x x
     ...                     xxx
 }

   dgs : array[0..9] of string[15]=(
   'xxxx xx xx xxxx',   {0}
   '  x  x  x  x  x',   {1}
   'xxx  xxxxx  xxx',   {2}
   'xxx  xxxx  xxxx',   {3}
   'x xx xxxx  x  x',   {4}
   'xxxx  xxx  xxxx',   {5}
   'xxxx  xxxx xxxx',   {6}
   'xxx  x  x  x  x',   {7}
   'xxxx xxxxx xxxx',   {8}
   'xxxx xxxx  xxxx');  {9}
var
   h,l : byte;
   i,j : integer;
     c : byte;
begin
 h:=n div 10;
 if h>9 then h:=9;
 l:=n mod 10;

 for i:=0 to 4 do
  for j:=0 to 2 do
   begin
    if dgs[h][1+i*3+j]='x' then c:=col else c:=0;
    bar(x+j*6,y+i*6,x+j*6+5,y+i*6+5,c);
   end;
 inc(x,24);
 for i:=0 to 4 do
  for j:=0 to 2 do
   begin
    if dgs[l][1+i*3+j]='x' then c:=col else c:=0;
    bar(x+j*6,y+i*6,x+j*6+5,y+i*6+5,c);
   end;
end;

{ restart ball }
procedure resball;
begin

 if not auto and not KTB[$39] then
  begin
   vx:=0; vy:=0;
   bx:=317; by:=480;
   exit;
  end;

 bx:=32; by:=40+random(400);
 vx:=vxt[spd]; vy:=vyt[spd,0];
 if random(100)>30 then vy:=-vy;
 if (ang=1)and(random(100)>60) then vy:=vyt[spd,1];

 if KTB[$39] then while KTB[$39] do;
end;

{ show the scores }
procedure shnums;
begin
 case gtype of
 0,1: begin
       shdig(250,20,cl_pl0,pl[0].sc);
       shdig(345,20,cl_pl1,pl[1].sc);
      end;
   2: shdig(100,20,cl_pl0,pl[0].sc);
   3: begin
       shdig(100,20,cl_pl0,pl[0].sc);
       shdig(170,20,cl_pl1,pl[1].sc);
      end;
 end;
end;

{ ball moving }
procedure moveball;
begin
 if (bx<6) then
  begin
   if ((by>miny)and(by+5<maxy))and(gtype<2) then
    begin
     hideball;
     resball;
     if not gameover then inc(pl[1].sc);
     shnums;
     goalsnd;
    end
   else begin {beep(300);} vx:=-vx; end;
  end;

 if (bx>628) then
  begin
   if (by>miny)and(by+5<maxy) then
    begin
     hideball;
     resball;
     if not gameover then inc(pl[0].sc);
     shnums;
     goalsnd;
    end
   else begin {beep(300);}vx:=-vx; end;
  end;

 if (by<5)or(by>468) then
  begin
   {beep(300)}; vy:=-vy;
   if (ang=1)and(abs(vy)<2)and(random(100)>60) then vy:=2*vy;
  end;

 inc(bx,vx);
 inc(by,vy);

end;

{ palyer moving }
procedure movepl(idx,up,dn:integer);
begin
 with pl[idx] do
 begin
  oy:=y;
  if not(ktb[up] or ktb[dn]) then begin dy:=4; ctr:=0; end;
  if ktb[up] then
   begin
    if y+len>10 then dec(y,dy);
    inc(ctr);
    if ctr=20 then
     begin
      if dy<10 then inc(dy);
      ctr:=0;
     end;
   end;

  if ktb[dn] then
   begin
    if y<465 then inc(y,dy);
    inc(ctr);
    if ctr=20 then
     begin
      if dy<10 then inc(dy);
      ctr:=0;
     end;
   end;

 end;
end;

{ hide players based on game type }
procedure hidepls;
begin
  with pl[0] do Hidercq(x,oy,len,cl_pl0);
  if gtype<>2 then with pl[1] do Hidercq(x,oy,len,cl_pl1);

  if gtype=1 then
   begin
    with pl[0] do Hidercq(x2,oy,len,cl_pl0);
    with pl[1] do Hidercq(x2,oy,len,cl_pl1);
    if handicap then
     with pl[1] do Hidercq(x2+300,oy,len,cl_pl1);
   end;
end;

{ show players based on game type }
procedure showpls;
begin
  with pl[0] do rcq(x,y,len,cl_pl0);
  if gtype<>2 then with pl[1] do rcq(x,y,len,cl_pl1);

  if gtype=1 then
   begin
    with pl[0] do rcq(x2,y,len,cl_pl0);
    with pl[1] do rcq(x2,y,len,cl_pl1);
    if handicap then
      with pl[1] do rcq(x2+300,y,len,cl_pl1);
   end;
end;


{
 bx,by : a labda pozicioja - ball position
}
procedure rchk(plidx:byte); { check for ball-racquet collision }
var
   lx,ly : integer;
      dr : integer;
     hit : boolean;
     myx : integer;
     idx : byte;
begin
 idx:=plidx and 1;
 with pl[idx] do
 begin
  {gameover}
  if gameover then exit;
  {fuggolegesen kivul van, nem talalkoznak - racquet is not on the screen }
  if (by+5<y)or(by>(y+len)) then exit;

  if boolean(plidx and 2) then myx:=x2 else myx:=x;

  if plidx=5 then myx:=x2+300;

  {a labda vizszintes iranya - vertical direction +1 -1 }
  dr:=sgn(vx);

  {labda kozepenek pozicioja - position for the middle of the ball }
  lx:=bx+3;
  ly:=by+3;

  {el kellene donteni, hogy ut vagy atenged

   (idx=0 and dr=-1) : elso jatekos ut          1st player hits
   (idx=0 and dr=1)  : elso jatekos atenged     1st player lets it go
   (idx=1 and dr=1)  : masodik jatekos ut       2nd player hits
   (idx=1 and dr=-1) : masodik jatekos atenged  2nd plater lets it go
  }

  { hit=true: ut - hit  hit=false: atenged - let it go }
  hit:=((idx=0)and(dr=-1))or((idx=1)and(dr=1));

  if gtype in [2,3] then hit:=(dr=1);

  {az uto kozepvonala a ket jatekos eseteben}
  {if idx=0 then myx:=(myx shl 3)+5 else myx:=(myx shl 3)+2;}

  {ha 4 pixelen belul van az uto kozepvonalahoz kepest}
  if (abs(myx-lx)<4) then
  case hit of
  true:{visszautes}
       begin
        beep(500+idx*200);
        vx:=-vx;
        if boolean(ang)and(random(100)>30) then
         vy:=sgn(vy)*vyt[spd,1]
        else
         vy:=sgn(vy)*vyt[spd,0];
       end;
  false:{atengedes}
       begin
        beep(900+idx*200);
        if random(100)>40 then vy:=-vy;
        if boolean(ang)and(random(100)>30) then
         vy:=sgn(vy)*vyt[spd,1]
        else
         vy:=sgn(vy)*vyt[spd,0];
       end;
  end;

 end;
end;

procedure SetPl(idx,_x,_x2:integer);
begin
 with pl[idx] do
  begin
    x:=_x;
    y:=100;
   dy:=2;
  ctr:=0;
   x2:=_x2;
   sc:=0;
  end;
end;

{ set the game type }
procedure SetGameType(k:byte);
begin

 handicap:=false;

 miny:=-10;
 maxy:=500;

 inc(gtype);
 gtype:=gtype and 3;

 {clear screen}
 portw[$03c4]:=$0f02;
 fillchar(mem[$a000:0],38400,$00);

 {horizontal bars on top and bottom}
 bar(0,0,639,5,cl_fld);
 bar(0,474,639,479,cl_fld);

 {vertical bars to half the screen}
 if gtype in [0,1] then
  begin
   if gtype=0 then
    for i:=0 to 31 do
     bar(317,i*15,321,i*15+5,cl_fld)
   else
    for i:=0 to 119 do
     bar(317,i*4,321,i*4+1,cl_fld);

   SetPl(0,12,639-150);
   SetPl(1,639-12,150);
  end;

 if gtype=1 then
  begin
   bar(0,0,5,100,cl_fld);
   bar(0,380,5,479,cl_fld);
   bar(634,0,639,100,cl_fld);
   bar(634,380,639,479,cl_fld);

   miny:=100;
   maxy:=380;
  end;

 if gtype in [2,3] then
  begin
   for i:=0 to 119 do
    bar(0,i*4,5,i*4+1,cl_fld);
   if gtype=2 then
    begin
     SetPl(0,400,0);
    end
   else
    begin
     SetPl(0,400,0);
     SetPl(1,408,0);
    end;
  end;

 shnums;

 while KTB[k] do;
end;

{ the different states are shown on the top-left side of the screen }
procedure ShStates;
begin
 if len=40 then shbmp(1,1,cl_fld,@ikon0)
           else shbmp(1,1,cl_fld,@ikon1);
 if spd=0 then shbmp(4,1,cl_fld,@ikon2)
          else shbmp(4,1,cl_fld,@ikon3);
 if ang=0 then shbmp(7,1,cl_fld,@ikon4)
          else shbmp(7,1,cl_fld,@ikon5);
 if snd   then shbmp(10,1,cl_fld,@ikon6)
          else shbmp(10,1,cl_fld,@ikon7);

end;

{ size of the racquet }
procedure RacSize(k:byte);
begin
 if len=40 then len:=25 else len:=40;
 while KTB[k] do;
end;

{ speed handling }
procedure Speed(k:byte);
var ox,oy : integer;
begin
 spd:=spd xor 1;
 ox:=vx;
 oy:=vy;
 vx:=vxt[spd]; vy:=vyt[spd,0];
 if ox<0 then vx:=-vx;
 if oy<0 then vy:=-vy;
 while KTB[k] do;
end;

{ angle }
procedure Angle(k:byte);
begin
 ang:=ang xor 1;
 while KTB[k] do;
end;

procedure ResNum(k:byte);
begin
 pl[0].sc:=0;
 pl[1].sc:=0;
 shnums;
 while KTB[k] do;
end;

procedure SetSnd(k:byte);
begin
 snd:=not snd;
 while KTB[k] do;
end;

procedure SetAuto(k:byte);
begin
 auto:=not auto;
 while KTB[k] do;
 if auto and (by=480) then resball;
end;

procedure Handi(k:byte);
begin
 handicap:=not handicap;
 while KTB[k] do;
end;


BEGIN
 graphon; { 640x480x16 standard VGA mode }

 { "serialize" the EGA palette }
 for i:=0 to 15 do SetEGA(i,i);

 { set the colors }
 SetRGB(cl_pl0,$00,$20,$3f);    { player #1 - blue  }
 SetRGB(cl_pl1,$3f,$0f,$00);    { player #2 - red   }
 SetRGB(cl_ball,$3f,$3f,$3f);   { ball      - white }
 SetRGB(cl_fld,$00,$1f,$00);    { playfield - green }

 bx:=320;
 by:=240;
 vx:=0;
 vy:=0;
 resball;
 Ball(bx,by,8);

 InstallKeyIRQ;  { our own keyboard handler }

 spd:=0;
 ang:=0;
 len:=40;
 snd:=false;
 auto:=false;

 gtype:=3;
 setgametype($01);

 shnums;

 { MAIN GAME CYCLE }
 repeat
  waitrtc;
  HidePls;
  HideBall;

  {F1} if KTB[$3b] then RacSize($3b);
  {F2} if KTB[$3c] then Speed($3c);
  {F3} if KTB[$3d] then Angle($3d);
  {F4} if KTB[$3e] then SetSnd($3e);
  {F5} if KTB[$3f] then SetGameType($3f);
  {F6} if KTB[$40] then ResNum($40);
  {F7} if KTB[$41] then SetAuto($41);

  {F10}if KTB[$44] then Handi($44);

  {SPC}if KTB[$39] and not auto then resball;

  shstates;
  Ball(bx,by,cl_ball);
  ShowPls;
  moveball;
  movepl(0,$10,$2c);  { Q and Z }
  movepl(1,$49,$51);  { numpad 9 and numpad 3 }

  rchk(0);
  rchk(1);

  if gtype=1  then
   begin
    rchk(2);
    rchk(3);
    if handicap then rchk(5);
   end;

  gameover:=(pl[0].sc=15)or(pl[1].sc=15);

 until KTB[1]; { ESC }


 { reset the keyboard IRQ, then quit }
 UninstallKeyIRQ;

 graphoff;
END.
